/*******************************************************************************
* File Name: WP_Flash.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_WP_Flash_H) /* Pins WP_Flash_H */
#define CY_PINS_WP_Flash_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "WP_Flash_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 WP_Flash__PORT == 15 && ((WP_Flash__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    WP_Flash_Write(uint8 value);
void    WP_Flash_SetDriveMode(uint8 mode);
uint8   WP_Flash_ReadDataReg(void);
uint8   WP_Flash_Read(void);
void    WP_Flash_SetInterruptMode(uint16 position, uint16 mode);
uint8   WP_Flash_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the WP_Flash_SetDriveMode() function.
     *  @{
     */
        #define WP_Flash_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define WP_Flash_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define WP_Flash_DM_RES_UP          PIN_DM_RES_UP
        #define WP_Flash_DM_RES_DWN         PIN_DM_RES_DWN
        #define WP_Flash_DM_OD_LO           PIN_DM_OD_LO
        #define WP_Flash_DM_OD_HI           PIN_DM_OD_HI
        #define WP_Flash_DM_STRONG          PIN_DM_STRONG
        #define WP_Flash_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define WP_Flash_MASK               WP_Flash__MASK
#define WP_Flash_SHIFT              WP_Flash__SHIFT
#define WP_Flash_WIDTH              1u

/* Interrupt constants */
#if defined(WP_Flash__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in WP_Flash_SetInterruptMode() function.
     *  @{
     */
        #define WP_Flash_INTR_NONE      (uint16)(0x0000u)
        #define WP_Flash_INTR_RISING    (uint16)(0x0001u)
        #define WP_Flash_INTR_FALLING   (uint16)(0x0002u)
        #define WP_Flash_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define WP_Flash_INTR_MASK      (0x01u) 
#endif /* (WP_Flash__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define WP_Flash_PS                     (* (reg8 *) WP_Flash__PS)
/* Data Register */
#define WP_Flash_DR                     (* (reg8 *) WP_Flash__DR)
/* Port Number */
#define WP_Flash_PRT_NUM                (* (reg8 *) WP_Flash__PRT) 
/* Connect to Analog Globals */                                                  
#define WP_Flash_AG                     (* (reg8 *) WP_Flash__AG)                       
/* Analog MUX bux enable */
#define WP_Flash_AMUX                   (* (reg8 *) WP_Flash__AMUX) 
/* Bidirectional Enable */                                                        
#define WP_Flash_BIE                    (* (reg8 *) WP_Flash__BIE)
/* Bit-mask for Aliased Register Access */
#define WP_Flash_BIT_MASK               (* (reg8 *) WP_Flash__BIT_MASK)
/* Bypass Enable */
#define WP_Flash_BYP                    (* (reg8 *) WP_Flash__BYP)
/* Port wide control signals */                                                   
#define WP_Flash_CTL                    (* (reg8 *) WP_Flash__CTL)
/* Drive Modes */
#define WP_Flash_DM0                    (* (reg8 *) WP_Flash__DM0) 
#define WP_Flash_DM1                    (* (reg8 *) WP_Flash__DM1)
#define WP_Flash_DM2                    (* (reg8 *) WP_Flash__DM2) 
/* Input Buffer Disable Override */
#define WP_Flash_INP_DIS                (* (reg8 *) WP_Flash__INP_DIS)
/* LCD Common or Segment Drive */
#define WP_Flash_LCD_COM_SEG            (* (reg8 *) WP_Flash__LCD_COM_SEG)
/* Enable Segment LCD */
#define WP_Flash_LCD_EN                 (* (reg8 *) WP_Flash__LCD_EN)
/* Slew Rate Control */
#define WP_Flash_SLW                    (* (reg8 *) WP_Flash__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define WP_Flash_PRTDSI__CAPS_SEL       (* (reg8 *) WP_Flash__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define WP_Flash_PRTDSI__DBL_SYNC_IN    (* (reg8 *) WP_Flash__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define WP_Flash_PRTDSI__OE_SEL0        (* (reg8 *) WP_Flash__PRTDSI__OE_SEL0) 
#define WP_Flash_PRTDSI__OE_SEL1        (* (reg8 *) WP_Flash__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define WP_Flash_PRTDSI__OUT_SEL0       (* (reg8 *) WP_Flash__PRTDSI__OUT_SEL0) 
#define WP_Flash_PRTDSI__OUT_SEL1       (* (reg8 *) WP_Flash__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define WP_Flash_PRTDSI__SYNC_OUT       (* (reg8 *) WP_Flash__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(WP_Flash__SIO_CFG)
    #define WP_Flash_SIO_HYST_EN        (* (reg8 *) WP_Flash__SIO_HYST_EN)
    #define WP_Flash_SIO_REG_HIFREQ     (* (reg8 *) WP_Flash__SIO_REG_HIFREQ)
    #define WP_Flash_SIO_CFG            (* (reg8 *) WP_Flash__SIO_CFG)
    #define WP_Flash_SIO_DIFF           (* (reg8 *) WP_Flash__SIO_DIFF)
#endif /* (WP_Flash__SIO_CFG) */

/* Interrupt Registers */
#if defined(WP_Flash__INTSTAT)
    #define WP_Flash_INTSTAT            (* (reg8 *) WP_Flash__INTSTAT)
    #define WP_Flash_SNAP               (* (reg8 *) WP_Flash__SNAP)
    
	#define WP_Flash_0_INTTYPE_REG 		(* (reg8 *) WP_Flash__0__INTTYPE)
#endif /* (WP_Flash__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_WP_Flash_H */


/* [] END OF FILE */
